/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { Number_$type, typeCast, runOn, markType, markDep, Point_$type, fromEnum } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { MathUtil } from "igniteui-react-core";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { RangeValueList } from "./RangeValueList";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { Flattener } from "igniteui-react-core";
/**
 * @hidden
 */
var PriceChannelOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceChannelOverlay, _super);
    function PriceChannelOverlay() {
        var _this = _super.call(this) || this;
        _this.yc = new List$1(Number_$type, 0);
        _this.yb = new List$1(Number_$type, 0);
        _this.ab = PriceChannelOverlay.$;
        _this.uf = new CategoryFrame(3);
        _this.uh = new CategoryFrame(3);
        _this.ud = new CategoryFrame(3);
        return _this;
    }
    PriceChannelOverlay.prototype.bc = function () {
        return new PriceChannelOverlay();
    };
    PriceChannelOverlay.prototype.pa = function (a, b, c, d) {
        switch (b) {
            case "HighColumn":
            case "LowColumn":
                this.x5 = false;
                break;
        }
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case PriceChannelOverlay.$$p[0]:
                this.x5 = false;
                this.pr(false);
                break;
        }
    };
    PriceChannelOverlay.prototype.gm = function (a, b, c) {
        var d = _super.prototype.gm.call(this, a, b, c);
        if (this.u5 == null || this.u6 == null) {
            d = false;
        }
        return d;
    };
    PriceChannelOverlay.prototype.x6 = function () {
        this.yc.clear();
        this.yb.clear();
        var a = truncate(MathUtil.d(this.yd, 0, this.c7.count));
        var b = Math.min(this.u5.count, this.u6.count);
        var c = this.vv(this.u5);
        var d = this.vv(this.u6);
        for (var e = 0; e < b; e++) {
            var f = Math.min(a, e);
            var g = -1.7976931348623157E+308;
            var h = 1.7976931348623157E+308;
            for (var i = 0; i < f; i++) {
                if (!isNaN_(c.item(e - i))) {
                    g = Math.max(g, c.item(e - i));
                }
                if (!isNaN_(d.item(e - i))) {
                    h = Math.min(h, d.item(e - i));
                }
            }
            if (e == 0) {
                h = d.item(0);
                g = c.item(0);
            }
            this.yc.add(g);
            this.yb.add(h);
        }
        return true;
    };
    PriceChannelOverlay.prototype.xh = function (a, b) {
        _super.prototype.xh.call(this, a, b);
        var c = b.by;
        var d = b.bx;
        var e = this.getEffectiveViewport1(b);
        var f = new ScalerParams(0, c, d, this.ub.ch, e);
        var g = new ScalerParams(0, c, d, this.uu.ch, e);
        g.b = this.h3();
        var h = this.ub;
        var i = this.uu;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.ub);
        if (k != null && k.i$b.count != this.c7.count) {
            return;
        }
        j = this.v2(c, d, e);
        if (!this.x5) {
            this.x5 = this.x6();
        }
        g.b = this.h3();
        var l = this.ub.em(2, f) - this.ub.em(1, f);
        for (var m = b.b0.c; m <= b.b0.d; ++m) {
            var n = void 0;
            if (k == null) {
                n = b.b0.getBucket(m);
            }
            else {
                var o = k.i$b._inner[m];
                var p = k.i$d(o);
                var q = this.yc._inner[m];
                var r = this.yb._inner[m];
                var s = q;
                var t = r;
                var u = p;
                while (m < b.b0.d) {
                    o = k.i$b._inner[m + 1];
                    u = k.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s = Math.max(q, this.yc._inner[m]);
                    t = Math.min(r, this.yb._inner[m]);
                }
                if (!isInfinity(t) && !isInfinity(s)) {
                    var v = NaN;
                    if (!isNaN_(p)) {
                        v = this.ub.ej(p, f);
                    }
                    n = [v, t, s];
                }
                else {
                    n = [NaN, NaN, NaN];
                }
            }
            var w = Math.max(1, l);
            if (!isNaN_(n[0]) && m * w >= this.x7) {
                if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
                    n[0] = n[0] + j;
                }
                else {
                    n[0] = h.ej(n[0], f) + j;
                }
                n[1] = i.ej(n[1], g);
                n[2] = i.ej(n[2], g);
                a.f.add(n);
            }
        }
    };
    PriceChannelOverlay.prototype.nk = function (a, b) {
        _super.prototype.nk.call(this, a, b);
        var c = b;
        if (c != null) {
            c.b7();
        }
    };
    PriceChannelOverlay.prototype.xj = function (a, b) {
        _super.prototype.xj.call(this, a, b);
        var c = typeCast(PriceChannelOverlayView.$, b);
        if (c == null) {
            return;
        }
        var d = this.getEffectiveViewport1(b);
        if (b.b3(a)) {
            c.b7();
            var e_1 = a.f.count;
            var f = function (g) { return a.f._inner[g][0]; };
            var g = function (h) { return a.f._inner[e_1 - 1 - h][0]; };
            var h = function (i) { return a.f._inner[i][1]; };
            var i = function (j) { return a.f._inner[e_1 - 1 - j][2]; };
            c.b8(e_1, f, g, h, i);
            b.b5(a);
        }
        this.uk.a2(this, this.vj(), runOn(this, this.t3), this.v8(b), this.wa(b));
        var j = false;
        var k = this.uk.b;
        var l = a.f;
        var m = this.c7.count;
        if (k != null) {
            j = true;
        }
        if (j) {
            var n = new ScalerParams(0, b.by, b.bx, this.ub.ch, d);
            this.xg(l, -1, m, this.ub, n, b.q);
        }
        var o = c.ce;
        var p = c.cf;
        var q = c.ca;
        this.uk.ad(o, true, false, true, true);
        this.uk.ad(p, true, false, true, true);
        this.uk.ad(q, false, true, false, false);
        q._opacity = this.uk.j * this.hg;
    };
    PriceChannelOverlay.prototype.cd = function () {
        return new PriceChannelOverlayView(this);
    };
    PriceChannelOverlay.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.ya = typeCast(PriceChannelOverlayView.$, a);
    };
    PriceChannelOverlay.prototype.ia = function (a, b, c) {
        if (this.cv == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.cg);
        var e = new ScalerParams(0, this.cv.tr, this.cg.bx, this.ub.ch, d);
        var f = this.v2(this.cv.tr, this.cg.bx, d);
        return this.ic(new RangeValueList(this.yc, this.yb), a, this.ub, e, f, runOn(this, this.v1), b, c);
    };
    PriceChannelOverlay.prototype.je = function (a, b) {
        if (this.yc == null || this.yb == null) {
            return _super.prototype.je.call(this, a, b);
        }
        return this.jf(a, b, this.ub, runOn(this, this.v1), new RangeValueList(this.yc, this.yb));
    };
    PriceChannelOverlay.prototype.jg = function (a, b) {
        if (this.yc == null || this.yb == null) {
            return _super.prototype.jg.call(this, a, b);
        }
        return this.jh(a, b, this.ub, runOn(this, this.v1), new RangeValueList(this.yc, this.yb));
    };
    PriceChannelOverlay.prototype.h3 = function () {
        return Series.h5(this.yb, null);
    };
    PriceChannelOverlay.$t = markType(PriceChannelOverlay, 'PriceChannelOverlay', FinancialOverlay.$);
    PriceChannelOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, PriceChannelOverlay, 'raisePropertyChanged', ['Period:yd:yf', [1, 14]]);
    return PriceChannelOverlay;
}(FinancialOverlay));
export { PriceChannelOverlay };
/**
 * @hidden
 */
var PriceChannelBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceChannelBucketCalculator, _super);
    function PriceChannelBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    PriceChannelBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.a.b2.c7.count - 1);
        if (b <= c) {
            var d = -1.7976931348623157E+308;
            var e = 1.7976931348623157E+308;
            var f = 0;
            for (var g = b; g <= c; ++g) {
                if (!isNaN_(this.f.b6.yc._inner[g]) && !isNaN_(this.f.b6.yb._inner[g])) {
                    d = Math.max(d, this.f.b6.yc._inner[g]);
                    e = Math.min(e, this.f.b6.yb._inner[g]);
                    ++f;
                }
            }
            if (f > 0 && e != 1.7976931348623157E+308 && d != -1.7976931348623157E+308) {
                return [0.5 * (b + c), e, d];
            }
        }
        return [NaN, NaN, NaN];
    };
    PriceChannelBucketCalculator.$t = markType(PriceChannelBucketCalculator, 'PriceChannelBucketCalculator', FinancialBucketCalculator.$);
    return PriceChannelBucketCalculator;
}(FinancialBucketCalculator));
export { PriceChannelBucketCalculator };
/**
 * @hidden
 */
var PriceChannelOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceChannelOverlayView, _super);
    function PriceChannelOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.cb = new Polygon();
        _this.cg = new Polyline();
        _this.ch = new Polyline();
        _this.b6 = null;
        _this.b9 = new Polygon();
        _this.cc = new Polyline();
        _this.cd = new Polyline();
        _this.b6 = a;
        return _this;
    }
    Object.defineProperty(PriceChannelOverlayView.prototype, "ca", {
        get: function () {
            return this.cb;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PriceChannelOverlayView.prototype, "ce", {
        get: function () {
            return this.cg;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PriceChannelOverlayView.prototype, "cf", {
        get: function () {
            return this.ch;
        },
        enumerable: false,
        configurable: true
    });
    PriceChannelOverlayView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
        }
    };
    PriceChannelOverlayView.prototype.b1 = function () {
        return new PriceChannelBucketCalculator(this);
    };
    PriceChannelOverlayView.prototype.b7 = function () {
        this.cb.an.clear();
        this.cg.an.clear();
        this.ch.an.clear();
        this.as();
    };
    PriceChannelOverlayView.prototype.b8 = function (a, b, c, d, e) {
        var e_2, _a, e_3, _b;
        try {
            for (var _c = __values(fromEnum(Flattener.d(a, b, d, this.e.hk))), _d = _c.next(); !_d.done; _d = _c.next()) {
                var f = _d.value;
                this.cb.an.add({ $type: Point_$type, x: b(f), y: d(f) });
                this.cg.an.add({ $type: Point_$type, x: b(f), y: d(f) });
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(Flattener.d(a, c, e, this.e.hk))), _f = _e.next(); !_f.done; _f = _e.next()) {
                var g = _f.value;
                this.cb.an.add({ $type: Point_$type, x: c(g), y: e(g) });
                this.ch.an.add({ $type: Point_$type, x: c(g), y: e(g) });
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.as();
    };
    PriceChannelOverlayView.prototype.be = function () {
        _super.prototype.be.call(this);
        this.b9.an = this.cb.an;
        this.cc.an = this.cg.an;
        this.cd.an = this.ch.an;
        var a = this.br();
        this.b9._fill = a;
        this.b9._opacity = 1;
        this.cc._stroke = a;
        this.cc.ad = this.e.hl + 3;
        this.cd._stroke = a;
        this.cd.ad = this.e.hl + 3;
    };
    PriceChannelOverlayView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d) {
            if (b) {
                a.u(this.b9);
                a.v(this.cc);
                a.v(this.cd);
            }
            else {
                a.u(this.cb);
                a.v(this.cg);
                a.v(this.ch);
            }
        }
    };
    PriceChannelOverlayView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        this.e.a5.exportPolygonData(a, this.cb, "fill", ["Fill"]);
        this.e.a5.exportPolylineData(a, this.cg, "bottom", ["Lower", "Main"]);
        this.e.a5.exportPolylineData(a, this.ch, "top", ["Upper"]);
    };
    PriceChannelOverlayView.$t = markType(PriceChannelOverlayView, 'PriceChannelOverlayView', FinancialSeriesView.$);
    return PriceChannelOverlayView;
}(FinancialSeriesView));
export { PriceChannelOverlayView };
